
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>[转]&quot;undefined reference to&quot; 问题解决方法 / 憋错料</title>

    <meta name="description" content="[转]&quot;undefined reference to&quot; 问题解决方法 转载未能找到原文出处. 最近在Linux下编程发现一个诡异的现象,就是在链接一个静态库的时候总是报错,类似下面这样的错误: (.text+0x13): undefined reference to `func' 关于undefined reference这样的问题,大家其实经常会遇到,在此,我以详细地示例给出常见错误的各种原因以及解决方法,希望对初学者有所帮助. 1.  链接时缺失了相关目标文件(.o)     测试代码如下: 然后编译. gcc -c test.c gcc –c main.c">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">[转]&quot;undefined reference to&quot; 问题解决方法</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>转载未能找到原文出处.</p>
<p>最近在Linux下编程发现一个诡异的现象，就是在链接一个静态库的时候总是报错，类似下面这样的错误：</p>
<ol>
<li>(.text+0x13):&nbsp;undefined&nbsp;reference&nbsp;to&nbsp;`func‘</li>
</ol>
<p>关于undefined reference这样的问题，大家其实经常会遇到，在此，我以详细地示例给出常见错误的各种原因以及解决方法，希望对初学者有所帮助。</p>
<p><strong>1.&nbsp; 链接时缺失了相关目标文件（.o）</strong></p>
<p><strong>&nbsp;&nbsp;&nbsp;&nbsp;</strong><a href="http://lib.csdn.net/base/softwaretest" rel="external nofollow noreferrer">测试</a>代码如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS41MWN0by5jb20vYXR0YWNobWVudC8yMDEwMTEvMTMzMTQ0OTE0LnBuZw==.jpg"></p>
<p>然后编译。</p>
<ol>
<li>gcc&nbsp;-c&nbsp;test.c</li>
<li>gcc&nbsp;–c&nbsp;main.c</li>
</ol>
<p>得到两个 .o 文件，一个是 main.o，一个是 test.o ，然后我们链接 .o 得到可执行程序：</p>
<ol>gcc&nbsp;-o&nbsp;main&nbsp;main.o</ol>
<p>这时，你会发现，报错了：</p>
<ol>
<li>main.o:&nbsp;In&nbsp;function&nbsp;`main‘:</li>
<li>main.c:(.text+0x7):&nbsp;undefined&nbsp;reference&nbsp;to&nbsp;`test‘</li>
<li>collect2:&nbsp;ld&nbsp;returned&nbsp;1&nbsp;exit&nbsp;status</li>
</ol>
<p>这就是最典型的undefined reference错误，因为在链接时发现找不到某个函数的实现文件，本例中test.o文件中包含了test()函数的实现，所以如果按下面这种方式链接就没事了。</p>
<ol>
<li>gcc&nbsp;-o&nbsp;main&nbsp;main.o&nbsp;test.o</li>
</ol>
<p>【扩展】：其实上面为了让大家更加清楚底层原因，我把编译链接分开了，下面这样编译也会报undefined reference错，其实底层原因与上面是一样的。</p>
<ol>
<li>gcc&nbsp;-o&nbsp;main&nbsp;main.c&nbsp;//缺少test()的实现文件</li>
</ol>
<p>需要改成如下形式才能成功，将test()函数的实现文件一起编译。</p>
<ol>
<li>gcc&nbsp;-o&nbsp;main&nbsp;main.c&nbsp;test.c&nbsp;//ok,没问题了</li>
</ol>
<p><strong>2.&nbsp;&nbsp;&nbsp; 链接时缺少相关的库文件（.a/.so）</strong></p>
<p>在此，只举个静态库的例子，假设源码如下。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS41MWN0by5jb20vYXR0YWNobWVudC8yMDEwMTEvMTMzNzM0NDgzLnBuZw==.jpg"></p>
<p>先把test.c编译成静态库(.a)文件</p>
<ol>
<li>gcc&nbsp;-c&nbsp;test.c</li>
<li>ar&nbsp;-rc&nbsp;test.a&nbsp;test.o</li>
</ol>
<p>至此，我们得到了test.a文件。我们开始编译main.c</p>
<ol>
<li>gcc&nbsp;-c&nbsp;main.c</li>
</ol>
<p>这时，则生成了main.o文件，然后我们再通过如下命令进行链接希望得到可执行程序。</p>
<ol>
<li>gcc&nbsp;-o&nbsp;main&nbsp;main.o</li>
</ol>
<p>你会发现，编译器报错了：</p>
<ol>
<li>/tmp/ccCPA13l.o:&nbsp;In&nbsp;function&nbsp;`main‘:</li>
<li>main.c:(.text+0x7):&nbsp;undefined&nbsp;reference&nbsp;to&nbsp;`test‘</li>
<li>collect2:&nbsp;ld&nbsp;returned&nbsp;1&nbsp;exit&nbsp;status</li>
</ol>
<p>其根本原因也是找不到test()函数的实现文件，由于该test()函数的实现在test.a这个静态库中的，故在链接的时候需要在其后加入test.a这个库，链接命令修改为如下形式即可。</p>
<ol>
<li>gcc&nbsp;-o&nbsp;main&nbsp;main.o&nbsp;./test.a&nbsp;&nbsp;//注：./&nbsp;是给出了test.a的路径</li>
</ol>
<p>【扩展】：同样，为了把问题说清楚，上面我们把代码的编译链接分开了，如果希望一次性生成可执行程序，则可以对main.c和test.a执行如下命令。</p>
<ol>
<li>gcc&nbsp;-o&nbsp;main&nbsp;main.c&nbsp;./test.a&nbsp;&nbsp;//同样，如果不加test.a也会报错</li>
</ol>
<p><strong>3.&nbsp;&nbsp;&nbsp; 链接的库文件中又使用了另一个库文件</strong></p>
<p>这种问题比较隐蔽，也是我最近遇到的与网上大家讨论的不同的问题，举例说明如下，首先，还是看看测试代码。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS41MWN0by5jb20vYXR0YWNobWVudC8yMDEwMTEvMTM0MTU3MzM5LnBuZw==.jpg"></p>
<p>从上图可以看出，main.c调用了test.c的函数，test.c中又调用了fun.c的函数。<br />&nbsp;&nbsp;&nbsp; 首先，我们先对fun.c，test.c，main.c进行编译，生成 .o文件。</p>
<ol>
<li>gcc&nbsp;-c&nbsp;func.c</li>
<li>gcc&nbsp;-c&nbsp;test.c</li>
<li>gcc&nbsp;-c&nbsp;main.c</li>
</ol>
<p>然后，将test.c和func.c各自打包成为静态库文件。</p>
<ol>
<li>ar&nbsp;–rc&nbsp;func.a&nbsp;func.o</li>
<li>ar&nbsp;–rc&nbsp;test.a&nbsp;test.o</li>
</ol>
<p>这时，我们准备将main.o链接为可执行程序，由于我们的main.c中包含了对test()的调用，因此，应该在链接时将test.a作为我们的库文件，链接命令如下。</p>
<ol>
<li>gcc&nbsp;-o&nbsp;main&nbsp;main.o&nbsp;test.a</li>
</ol>
<p>这时，编译器仍然会报错，如下：</p>
<ol>
<li>test.a(test.o):&nbsp;In&nbsp;function&nbsp;`test‘:</li>
<li>test.c:(.text+0x13):&nbsp;undefined&nbsp;reference&nbsp;to&nbsp;`func‘</li>
<li>collect2:&nbsp;ld&nbsp;returned&nbsp;1&nbsp;exit&nbsp;status</li>
</ol>
<p>就是说，链接的时候，发现我们的test.a调用了func()函数，找不到对应的实现。由此我们发现，原来我们还需要将test.a所引用到的库文件也加进来才能成功链接，因此命令如下。</p>
<ol>
<li>gcc&nbsp;-o&nbsp;main&nbsp;main.o&nbsp;test.a&nbsp;func.a</li>
</ol>
<p>ok，这样就可以成功得到最终的程序了。同样，如果我们的库或者程序中引用了第三方库（如pthread.a）则同样在链接的时候需要给出第三方库的路径和库文件，否则就会得到undefined reference的错误。</p>
<p><strong>4 多个库文件链接顺序问题</strong></p>
<p>这种问题也非常的隐蔽，不仔细研究你可能会感到非常地莫名其妙。我们依然回到第3小节所讨论的问题中，在最后，如果我们把链接的库的顺序换一下，看看会发生什么结果？</p>
<ol>
<li>gcc&nbsp;-o&nbsp;main&nbsp;main.o&nbsp;func.a&nbsp;test.a</li>
</ol>
<p>我们会得到如下报错.</p>
<ol>
<li>test.a(test.o):&nbsp;In&nbsp;function&nbsp;`test‘:</li>
<li>test.c:(.text+0x13):&nbsp;undefined&nbsp;reference&nbsp;to&nbsp;`func‘</li>
<li>collect2:&nbsp;ld&nbsp;returned&nbsp;1&nbsp;exit&nbsp;status</li>
</ol>
<p>因此，我们需要注意，在链接命令中给出所依赖的库时，需要注意库之间的依赖顺序，依赖其他库的库一定要放到被依赖库的前面，这样才能真正避免undefined reference的错误，完成编译链接。</p>
<p><strong>5. 在c++代码中链接<a href="http://lib.csdn.net/base/c" rel="external nofollow noreferrer">C语言</a>的库</strong></p>
<p>如果你的库文件由c代码生成的，则在c++代码中链接库中的函数时，也会碰到undefined reference的问题。下面举例说明。</p>
<p>首先，编写c语言版库文件：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS41MWN0by5jb20vYXR0YWNobWVudC8yMDExMDkvMTUwMzU4NDY2LnBuZw==.jpg"></p>
<p>编译，打包为静态库：test.a</p>
<ol>
<li>gcc&nbsp;-c&nbsp;test.c</li>
<li>ar&nbsp;-rc&nbsp;test.a&nbsp;test.o</li>
</ol>
<p>至此，我们得到了test.a文件。下面我们开始编写c++文件main.cpp</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS41MWN0by5jb20vYXR0YWNobWVudC8yMDExMDkvMTUwNTUzMjg3LnBuZw==.jpg"></p>
<p>然后编译main.cpp生成可执行程序：</p>
<ol>
<li>g++&nbsp;-o&nbsp;main&nbsp;main.cpp&nbsp;test.a</li>
</ol>
<p>会发现报错：</p>
<ol>
<li>/tmp/ccJjiCoS.o:&nbsp;In&nbsp;function&nbsp;`main‘:</li>
<li>main.cpp:(.text+0x7):&nbsp;undefined&nbsp;reference&nbsp;to&nbsp;`test()‘</li>
<li>collect2:&nbsp;ld&nbsp;returned&nbsp;1&nbsp;exit&nbsp;status</li>
</ol>
<p>原因就是main.cpp为c++代码，调用了c语言库的函数，因此链接的时候找不到，解决方法：即在main.cpp中，把与c语言库test.a相关的头文件包含添加一个extern "C"的声明即可。例如，修改后的main.cpp如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS41MWN0by5jb20vYXR0YWNobWVudC8yMDExMDkvMTUwOTU5NDc2LnBuZw==.jpg"></p>
<ol>
<li>g++&nbsp;-o&nbsp;main&nbsp;main.cpp&nbsp;test.a</li>
</ol>
<p>再编译会发现，问题已经成功解决。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 22:04:58 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/text/" title="text">text</a>, <a href="https://www.biecuoliao.com/tag/tar/" title="tar">tar</a>, <a href="https://www.biecuoliao.com/tag/%e9%a2%98%e8%a7%a3/" title="题解">题解</a>, <a href="https://www.biecuoliao.com/tag/target/" title="target">target</a>, <a href="https://www.biecuoliao.com/tag/%e6%8a%a5%e9%94%99/" title="报错">报错</a>, <a href="https://www.biecuoliao.com/tag/sdn/" title="sdn">sdn</a>, <a href="https://www.biecuoliao.com/tag/%e6%89%93%e5%8c%85/" title="打包">打包</a>, <a href="https://www.biecuoliao.com/tag/%e9%97%ae%e9%a2%98%e8%a7%a3%e5%86%b3/" title="问题解决">问题解决</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>[转]&quot;undefined reference to&quot; 问题解决方法的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xZDQB4.html" rel="bookmark">&amp;quot&semi;undefined reference to&amp;quot&semi; 多种可能出现的问题解决方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近在Linux下编程发现一个诡异的现象,就是在链接一个静态库的时候总是报错,类似下面这样的错误: (.text+0x13): undefined reference to `func' 关于undefined reference这样的问题,大家其实经常会遇到,在此,我以详细地示例给出常见错误的各种原因以及解决方法,希望对初学者有所帮助. 1.  链接时缺失了相关目标文件(.o)     测试代码如下: 然后编译. gcc -c test.c gcc –c main.c 得到两个 .o 文件,一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RnWo90.html" rel="bookmark">&amp;amp&semi;quot&semi;undefined reference to&amp;amp&semi;quot&semi; 问题解决方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				近期在Linux下编程发现一个诡异的现象,就是在链接一个静态库的时候总是报错,类似以下这种错误: (.text+0x13): undefined reference to `func' 关于undefined reference这种问题,大家事实上常常会遇到,在此,我以具体地演示样例给出常见错误的各种原因以及解决方法,希望对刚開始学习的人有所帮助. 1.  链接时缺失了相关目标文件(.o)     測试代码例如以下: 然后编译. gcc -c test.c gcc –c main.c 得到两个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dNWKg4.html" rel="bookmark">undefined reference to &grave;pthread&lowbar;create&amp;&num;39&semi;问题解决</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在编译pthread有关的程序时,出现undefined reference to `pthread_create'这样的错误. 问题原因: pthread 库不是 Linux 系统默认的库,连接时需要使用静态库 libpthread.a,所以在使用pthread_create()创建线程,以及调用 pthread_atfork()函数建立fork处理程序时,需要链接该库. 问题解决: 方法一: 在编译中要加 -lpthread参数gcc thread.c -o thread -lpthread			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/n0lLDo0.html" rel="bookmark">Linux下运行《UNIX环境高级编程》undefined reference to &grave;err&lowbar;quit 编译出错的处理方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				错误信息: : undefined reference to `err_quit': undefined reference to `err_sys' 解决方法: 因为err_quit跟err_sys是作者自己定义的错误处理函数.所以最简单的解决办法是修改下apue.h文件,如下 /* * Our own header, to be included before all standard system headers. */ #ifndef _APUE_H #define _APUE_H #d			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0n11wXM.html" rel="bookmark">undefined reference to &grave;sin&amp;amp&semi;&num;39&semi;问题解决</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者:zhanhailiang 日期:2014-10-25 使用gcc编译例如以下代码时报&quot;undefined reference to `sin'&quot;: #include &lt;stdio.h&gt; #include &lt;math.h&gt; #include &lt;stdlib.h&gt;   main () { double a = sin(1); exit (0); } [root@~/wade/codeReview/learningc/9]# gcc -o timet			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/418JRg3.html" rel="bookmark">linux &plus; eclipse &plus; cdt 报错undefined &NewLine;reference&period;&period;&period;&period;&period;&period;好麻烦的，这位大牛给出的方法可行，特此MARK！！！！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://bbs.csdn.net/topics/390239632 kerosun kerosun 等级: 结帖率:96.92% 楼主 发表于: 2012-10-11 12:00:51 比如有一个tools工程,提供给其他工程通用的工具函数. 我现在的做法就只能是ctrl+c|ctrl+v一旦工具函数发生变化,还需要在用到这些函数的工程中更新,比较麻烦. 看到eclipse工程属性设置中有Project References,但是一直不会用.那位好心人能说说怎样实现我的需求. 更多0分享到			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmAOJ1M.html" rel="bookmark">undefined reference to &grave;sin&amp;&num;39&semi;问题解决</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者:zhanhailiang 日期:2014-10-25 使用gcc编译如下代码时报&quot;undefined reference to `sin'&quot;: #include &lt;stdio.h&gt; #include &lt;math.h&gt; #include &lt;stdlib.h&gt;   main () { double a = sin(1); exit (0); } [root@~/wade/codeReview/learningc/9]# gcc -o timetes			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49EzYb4.html" rel="bookmark">gcc&sol;g&plus;&plus; undefined reference to function&lpar;&rpar; 问题的解决方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				g++ 编译一个程序g++ shm.c -o shm, 用到了 shm_open(), shm_unlink()函数,编译出现了下面的错误: /tmp/ccL2cbha.o: In function `del_resource()': shm.c:(.text+0x1b3): undefined reference to `shm_unlink' /tmp/ccL2cbha.o: In function `main': shm.c:(.text+0x872): undefined referen			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YKjBW4.html" rel="bookmark">undefined reference to &grave;clock&lowbar;gettime&amp;&num;39&semi; 链接错误问题解决</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当你编译程序时, 碰到下面的链接错误, timeval.c:(.text+0x6f): undefined reference to `clock_gettime' 则你只需要在你的Makefile文件里面添加    -lrt  ,重新编译即可. undefined reference to `clock_gettime' 链接错误问题解决			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q0xQw73.html" rel="bookmark" class="title">数据结构基本概念</a>
					<div>
						什么是数据结构 &quot;数据结构是数据对象,以及存在于该对象的实例和组成实例的数据元素之间的各种联系.这些联系可以通过定义相关的函数来给出&quot;--Sartaj Sahni,&lt;数据结构 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/x0dJQg4.html" rel="bookmark" class="title">openstack neutron数据库</a>
					<div>
						一．Neutron 数据库的整体架构图 Neutron Database采用的是分布式架构,由3台服务器组成一个cluster.Neutron Server通过Plugin,然后发送给Neutron  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9MBrzKM.html" rel="bookmark" class="title">Cisco交换机 配置zone</a>
					<div>
						1.配置Zone switch#conf t switch(config)#zone name zonename1 vsan 10 创建ZONE: switch(config-zone)#member ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wvyyV0.html" rel="bookmark" class="title">MySql数据库中乱码问题解决方案</a>
					<div>
						show variables like 'character%';    //查看当前各系统位置的字符编码格式 问题一: Incorrect string value: '\xB4\xF3\xB4\x ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rvYba3.html" rel="bookmark" class="title">Linux系统中如何挂载windows共享&lpar;cifs&rpar;，NFS共享，以及挂载ISO文件</a>
					<div>
						# 在Linux系统中挂载Windows中共享的文件夹: mount -t cifs //192.168.1.102/studyshare /mnt -o username=chocolee,pass ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWYpPm3.html" rel="bookmark" class="title">8月13日</a>
					<div>
						DataSetObserverble 是Observerble 的具体实例, 提供了Observerble 的一些方法 向DataSetObserver 列表发送通知. public class Da ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rkaz14.html" rel="bookmark" class="title">［我的疑问］String&quest; &equals; &amp;quot&semi;Skiy Chan&amp;quot&semi; 中的问号是什么意思？</a>
					<div>
						1 var optionalName : String? = &quot;Skiy Chan&quot; String? = &quot;Skiy Chan&quot; 中的问号是什么意思?目前还在看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MylbEa4.html" rel="bookmark" class="title">&period;DS&lowbar;Store 文件是什么&quest;Mac下面如何禁止&period;DS&lowbar;Store生成</a>
					<div>
						.DS_Store是Mac OS保存文件夹的自定义属性的隐藏文件,如文件的图标位置或背景色,相当于Windows的desktop.ini. 1,禁止.DS_store生成:打开 &quot;终端&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoxyJQ0.html" rel="bookmark" class="title">两个大的整数的运算（java）</a>
					<div>
						1 import java.math.BigInteger; 2 3 public class BigInt { 4 BigInteger m1; 5 BigInteger m2; 6 BigInte ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02ZL6E0.html" rel="bookmark" class="title">java基础第五天&lowbar;静态代码块、类的继承和接口</a>
					<div>
						1.文字阐述静态代码块的作用. 静态代码块在类加载的时候执行,而且只执行一次. 2.构造代码块与构造函数的调用顺序如何?和方法的声明位置是否有关?为什么?构造代码块的作用是什么? 构造代码块调用顺序优 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyWnrV3.html" rel="bookmark" class="title">驱动程序入门篇</a>
					<div>
						驱动程序分为两类: 一个是 Kernel(内核) 模式驱动,另一个是 Windows (用户窗口层)模式驱动. 这两种模式本质是相同,但细节不同.本文介绍的是内核模式驱动和驱动程序的安装与使用. 驱动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXnbra3.html" rel="bookmark" class="title">会变色的文字</a>
					<div>
						public class paint extends JFrame{ public paint(){ setLocation(0, 0); setSize(400, 400); setDefaultC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35wYdnM.html" rel="bookmark" class="title">解决 Cinder 僵尸卷问题</a>
					<div>
						目录 目录 问题描述 问题解决 最后 问题描述 Cinder 的僵尸卷一般是因为操作不当导致分配的卷无法正常使用且无法正常分离或删除. 问题解决 解决僵尸卷问题的思路类似解决 Linux 系统中的僵尸 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qxZDz0.html" rel="bookmark" class="title">Elasticsearch 调优 （官方文档How To）</a>
					<div>
						How To Elasticsearch默认是提供了一个非常简单的即开即用体验.用户无需修改什么配置就可以直接使用全文检索.结果高亮.聚合.索引功能. 但是想在项目中使用高性能的Elasticsear ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vz2Yo3.html" rel="bookmark" class="title">vc 串口精灵软件分析</a>
					<div>
						前几天找这个源码,没有找到,今天找到了,梳理一下关键实现代码: 主界面如下: 打开软件,设置初始的变量,串口参数: // CCommWizardDlg dialog CCommWizardDlg::C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MD82r7M.html" rel="bookmark" class="title">JSP中的邮件收发&lpar;1&rpar;</a>
					<div>
						JavaMail API是发送和接收电子邮件信息的可选包,将下载到的压缩包解压,将解压目录中的mail.jar和lib文件夹下面的所有jar类包都拷贝到站点类路径中,此外,还需下载JavaBeans  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38pxjW3.html" rel="bookmark" class="title">html中的meta详解</a>
					<div>
						1  name=viewport &lt;meta name=&quot;viewport&quot; content=&quot;width=device-width,initial-scale=1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38pJnn3.html" rel="bookmark" class="title">Install PHP 7&comma; Apache&comma; MySQL 5&period;6 on CentOS &sol; RHEL 7&period;1 &amp;amp&semi; 6&period;7 &plus; Wordpress</a>
					<div>
						最近做了个小项目,挣了几百块钱,于是买了个域名:shawshining.com 和一个搬瓦工的服务器.搬瓦工自带CentOS6,支持一键安装ss,比较方便.买的搬瓦工的服务器只有500MB内存,导致出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xBjPz4.html" rel="bookmark" class="title">mysql数据库时间戳与正常时间格式之间的转换</a>
					<div>
						mysql时间转换成时间戳create_time between UNIX_TIMESTAMP('2015-11-20 00:00:00') and UNIX_TIMESTAMP('2015-11-2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l1BqX3.html" rel="bookmark" class="title">剑指Offer39 数组中寻找和为sum的两个数字</a>
					<div>
						1 /************************************************************************* 2 &gt; File Name: 39_Tw ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.021 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
